checkRequire("Lua_ChaosForestHurtRewardPanel");
Lua_ChaosForestWindow = class("Lua_ChaosForestWindow", Lua_Window)
function Lua_ChaosForestWindow:ctor()
	self:superCall("ctor");

	self.layer = MainWinDefine.MAIN_MENU_TOP_LAYER;
	self.windowName = "Lua_ChaosForestWindow";
	self.skinName = "ChaosForestWindow_skin";
	self.isFullSizeWin = true;
	self.isSingleShowWin = true;
end

function Lua_ChaosForestWindow:buildShowItem()
	self:superCall("buildShowItem");
	self.hurtObject:SetActive(false);
	self.raidersObject:SetActive(false);
	self.recordId = 0;

    self.roleInfoPanel = Lua_RoleInfoPanel.new(self.content)
    self.roleInfoPanel:setRectAnchor(1)

	self.redPoint_record = Lua_RedPointIcon.new(self.content, Lua_RedPointList.ChaosForest_Record);
	self.redPoint_record:setRectAnchor(1);
	self.redPoint_record:setLocation(-270, -200, 0);

	self.hurtPanel = Lua_ChaosForestHurtRewardPanel.new(self.content);
	self.hurtPanel:setRectAnchor(7);
	self.hurtPanel:setLocation(50, 550, 0);

	self.curRankItem = Lua_SpliceTextItem.new(self.hurtObject);
	self.curRankItem:setRectAnchor(7);
	self.curRankItem:setLocation(100, 404, 0);
	self.curRankItem.pivot = 1;
	self.curRankItem:setLeftStyle(Lua_MyUISettings.fangzhengFontName, 22, "80F658");
	self.curRankItem:setRightStyle(Lua_MyUISettings.defaultFontName, 22, "80F658");

	self.btnInfo = Array();
	self.btnInfo:add(340000);
	self.btnInfo:add(340001);

	self.buttonList = Lua_ButtonList.new(self.content, Lua_AxisDefine.Horizontal);
	self.buttonList:setRectAnchor(7);
	self.buttonList:setLocation(-185, 464, 0);
	self.buttonList:setButtonCell(Lua_CommonButtonItem1);
	self.buttonList:setButtonItem(170, 57);
	self.buttonList:setClickCallBack(self, self.onButtonClick);
	self.buttonList:setData(self.btnInfo);
	self.buttonList:setSelected(1);

    self:createBackBtn();
	
	self.checkHelp:addClickFuntion(self, self.onCheckHelp);
	self.checkRank:addClickFuntion(self, self.onCheckRank);
	self.checkNotice:addClickFuntion(self, self.onCheckNotice);
	self.checkRecord:addClickFuntion(self, self.onCheckRecord);
	self.checkReward:addClickFuntion(self, self.onCheckReward);
	self.btnChallenge:addClickFuntion(self, self.onBtnChallengeClick);

	self:addLuaEvent("FIGHTPLAY_ENTER", self, self.checkIsFighting);
	self:addLuaEvent("FIGHTPLAY_COMPLETE", self, self.checkIsFighting);
	self:addLuaEvent("CHAOSFOREST_UPDATE", self, self.updateServerInfo);
	Lua_ProxyManager.getProxy("Lua_ChaosForestProxy"):sWinInfo();
end

function Lua_ChaosForestWindow:onBackBtnClick()
	DataCenter.funcPathUtil:gotoFunction(1035, true);
end

function Lua_ChaosForestWindow:dispose()
	self:stopTimer();
	DataCenter.preLoadData:removeBySign("Lua_FightLineupWindow", self, self.onSceneShow);
	if self.roleInfoPanel then
		self.roleInfoPanel:dispose()
		self.roleInfoPanel = nil
	end
	if self.redPoint_record ~= nil then
		self.redPoint_record:dispose();
		self.redPoint_record = nil;
	end
	if self.hurtPanel ~= nil then
		self.hurtPanel:dispose();
		self.hurtPanel = nil;
	end
	if self.curRankItem then
		self.curRankItem:dispose();
		self.curRankItem = nil;
	end
	if self.buttonList ~= nil then
		self.buttonList:dispose();
		self.buttonList = nil;
	end
	if self.btnInfo ~= nil then
		self.btnInfo:clear();
		self.btnInfo = nil;
	end
	if self.hurtReward ~= nil then
		self.hurtReward:dispose();
		self.hurtReward = nil;
	end
	if self.rankReward ~= nil then
		self.rankReward:dispose();
		self.rankReward = nil;
	end
	if self.tagArr ~= nil then
		self.tagArr:dispose();
		self.tagArr:clear();
		self.tagArr = nil;
	end
	if self.skillArr ~= nil then
		self.skillArr:dispose();
		self.skillArr:clear();
		self.skillArr = nil;
	end
	if self.modelScenePanel then
		self.modelScenePanel:dispose()
		self.modelScenePanel = nil
	end
	self.modelData = nil
	self:superCall("dispose");
end

function Lua_ChaosForestWindow:showWin(param)
	self:superCall("showWin", param);

	if param.modelScenePanel then
		if self.modelScenePanel ~= nil and self.modelScenePanel ~= param.modelScenePanel then
            self.modelScenePanel:dispose();
            self.modelScenePanel = nil;
        end
        
		self.modelScenePanel = param.modelScenePanel
		self.modelScenePanel:setParent(self.content)
		self.modelScenePanel:setRotBgDimensions(720, 720)
		self.modelScenePanel:setRotBgPos(0, 130)
		param.modelScenePanel = nil
	end
end

function Lua_ChaosForestWindow:resetActive(bActive)
	self:superCall("resetActive", bActive);
	if bActive then
		if self.modelData then
			local data = self.modelData
			self.modelData = nil
			self:showModel(data);
		end
	else
		if self.modelScenePanel then
			self.modelScenePanel:dispose();
			self.modelScenePanel = nil;
		end
	end
end

function Lua_ChaosForestWindow:checkIsFighting(templateId)
	if templateId == Lua_FightDefine.TEMPLATE_ID_CHAOSFOREST then
		self:updateBtnState();
	end
end

function Lua_ChaosForestWindow:updateBtnState()
	self.recordId = DataCenter.fightData:getRecordIdByTemplateId(Lua_FightDefine.TEMPLATE_ID_CHAOSFOREST);
	if self.recordId > 0 then
		self.btnChallenge:setLangValue(340006);
	else
		self.btnChallenge:setLangValue(340005);
	end
end

function Lua_ChaosForestWindow:updateServerInfo()
	self:updateBtnState();
	
	local data = DataCenter.chaosForestData;
	local config = DataCenter.chaosForestUtil:getLevelConfig(data.boss_id);
	if config == nil then
		return;
	end

	self.nameText.text = config.name;
	self.nameText:resetSize();
	self.levelText.text = config.level_str--LanUtil.formateStr(340002, tostring(config.level));

	local monsterConfig = Lua_MonsterPlayerConfigData.getConfigData(config.monster_id);
	local monsterId = monsterConfig.fighter_list[1][1][1];
	monsterConfig = Lua_MonsterConfigData.getMonsterConfig(monsterId);
	self:showModel(monsterConfig.heroVo)

	self.hurtPanel:updateShowInfo();
	self.maxHurtText.text = data.high_hurt;
	if data.rank <= 0 then
		self.curRankItem:setData(LanUtil.getValue(340010), LanUtil.getValue(340009));
	else
		self.curRankItem:setData(tostring(data.rank), LanUtil.getValue(340009));
	end

	local free_times = DataCenter.chaosForestUtil:getConstConfig("free_times", 1, 0);
	local left_times = free_times - data.challenge_times;
	if left_times <= 0 then
		left_times = Lua_ColorDefine.getColorStr("FF6553", left_times);
	else
		left_times = Lua_ColorDefine.getColorStr("80F658", left_times);
	end
	self.leftTimes.text = LanUtil.formateStr(340011, tostring(left_times), tostring(free_times));

	self:checkSettlement();
	self:showHurtReward(data.high_hurt);
	self:showRankReward(data.rank);
	self:showTag(config.tag_list);
	self:showSkill(monsterConfig.skill_list);
end

function Lua_ChaosForestWindow:checkSettlement()
	local data = DataCenter.chaosForestData;
	local serverTime = DataCenter.roleData.serverTime;
	if serverTime >= data.close_tick and serverTime < data.open_tick then
		self.bSettlement = true;
		self.btnChallenge:setLangValue(340007);
		self.endTick = data.open_tick;
	else
		self.bSettlement = false;
		self.btnChallenge:setLangValue(340005);
		self.endTick = data.close_tick;
	end

	local second = self.endTick - DataCenter.roleData.serverTime;
	if second > 0 then
		self:startTimer();
		self:onTimer();
	else
		self:stopTimer();
		self.timeText.text = nil;
	end
end

function Lua_ChaosForestWindow:showHurtReward(hurt)
	local arr = DataCenter.chaosForestUtil:getHurtRewardArr();
	local config;
	local targetHurt;
	local reward;
	for i = 1, arr:getSize() do
		config = DataCenter.chaosForestUtil:getHurtRewardInfo(arr[i]);
		if hurt < config.hurt then
			targetHurt = config.hurt;
			reward = config.reward;
			break;
		end
	end

	if targetHurt == nil then
		self.hurt_prompt_1:setLangValue(340012);
	else
		self.hurt_prompt_1.text = LanUtil.formateStr(340013, tostring(targetHurt));
	end

	if self.hurtReward == nil then
		local itemW = Mathf.Ceil(124 * 0.8);
		local width = itemW * 2.5 + 20;
		self.hurtReward = Lua_DragList.new(self.hurtObject, width, itemW, Lua_AxisDefine.Horizontal);
		self.hurtReward:setRectAnchor(7);
		self.hurtReward:setLocation(-205, 290, 0);
		self.hurtReward:setListCell(Lua_ChaosForestItemIconCell, itemW, itemW, 1);
		self.hurtReward:setCellSpacing(10, 0);
	end
	self.hurtReward:setArrayData(reward);
end

function Lua_ChaosForestWindow:showRankReward(rank)
	if rank <= 0 then
		self.hurt_prompt_2:setEnable(false);
		self.hurt_prompt_3:setLangValue(340014);
	else
		self.hurt_prompt_2:setEnable(true);
		self.hurt_prompt_3.text = nil;

		local config = DataCenter.chaosForestUtil:getRankRewardConfig();
		local reward;
		local rank_range;
		for i = 1, #config do
			rank_range = config[i].rank_range;
			if rank >= rank_range[1] and rank <= rank_range[2] then
				reward = config[i].reward;
			end
		end
		if reward == nil then
			if self.rankReward ~= nil then
				self.rankReward:setEnable(false);
			end
		else
			if self.rankReward == nil then
				local itemW = Mathf.Ceil(124 * 0.8);
				local width = itemW * 3 + 20;
				self.rankReward = Lua_DragList.new(self.hurtObject, width, itemW, Lua_AxisDefine.Horizontal);
				self.rankReward:setRectAnchor(7);
				self.rankReward:setLocation(155, 290, 0);
				self.rankReward:setListCell(Lua_ChaosForestItemIconCell, itemW, itemW, 1);
				self.rankReward:setCellSpacing(10, 0);
			end
			self.rankReward:setEnable(true);
			self.rankReward:setArrayData(reward);
		end
	end
end

function Lua_ChaosForestWindow:showTag(list)
	if self.tagArr == nil then
		self.tagArr = Array();
	end
	local len = self.tagArr:getSize();
	local dataLen = #list;
	local maxLen = dataLen > len and dataLen or len;
	local item;
	for i = 1, maxLen do
		item = self.tagArr[i];
		if i > dataLen then
			if item ~= nil then
				item:setEnable(false);
			end
		else
			if item == nil then
				item = Lua_ChaosForestTagItem.new(self.raidersObject);
				self.tagArr:add(item);
			else
				item:setEnable(true);
			end
			item:setRectAnchor(7);
			item:setLocation(-150 + (i - 1) * 175, 395, 0);
			item:setData(list[i]);
		end
	end
end

function Lua_ChaosForestWindow:showSkill(list)
	if self.skillArr == nil then
		self.skillArr = Array();
	end
	local len = self.skillArr:getSize();
	local dataLen = list == nil and 0 or #list;
	local arr = Array();
	local configData;
	for i = 1, dataLen do
		configData = Lua_SkillConfigData.getConfigData(list[i]);
		if configData.show_type ~= 1 then
			arr:add(configData);
		end
	end
	dataLen = arr:getSize();
	local maxLen = dataLen > len and dataLen or len;
	local item;
	for i = 1, maxLen do
		item = self.skillArr[i];
		if i > dataLen then
			if item ~= nil then
				item:setEnable(false);
			end
		else
			if item == nil then
				item = Lua_SkillIconItem.new(self.raidersObject);
				item:setCanClick(true);
				self.skillArr:add(item);
			else
				item:setEnable(true);
			end
			item:setRectAnchor(7);
			item:setLocation(-170 + (i - 1)* 130, 300, 0);
			item:setData(arr[i]);
		end
	end
	arr:clear();
	arr = nil;
end

function Lua_ChaosForestWindow:onButtonClick(index)
	if self.selectedIdx == index then
		return;
	end
	self.selectedIdx = index;

	if index == 1 then
		self.hurtObject:SetActive(true);
		self.raidersObject:SetActive(false);
	elseif index == 2 then
		self.hurtObject:SetActive(false);
		self.raidersObject:SetActive(true);
	end
end

function Lua_ChaosForestWindow:startTimer()
	if self.bTimer ~= true then
		self.bTimer = true;
		self:addTimer("Lua_ChaosForestWindow", 1, self, self.onTimer);
	end
end

function Lua_ChaosForestWindow:stopTimer()
	if self.bTimer == true then
		self.bTimer = false;
		self:removeTimer(self, self.onTimer);
	end
end

function Lua_ChaosForestWindow:onTimer()
	local second = self.endTick - DataCenter.roleData.serverTime;
	if second > 0 then
		if self.bSettlement == true then
			self.timeText:setLangValue(340004);
		else
			self.timeText.text = LanUtil.formateStr(340003, Lua_TimeTransform.transSeconds9(second));
		end
	else
		self:stopTimer();
		self.timeText.text = nil;
		-- if self.bSettlement == true then
		-- 	Lua_ProxyManager.getProxy("Lua_ChaosForestProxy"):sWinInfo();
		-- else
		-- 	self:checkSettlement();
		-- end
	end
end

function Lua_ChaosForestWindow:showModel(data)
	self.modelData = data
	if self.modelScenePanel == nil then
		self.modelScenePanel = Lua_ModelScenePanel.new()
		self.modelScenePanel:setParent(self.content)
		self.modelScenePanel:setRotBgDimensions(720, 720)
		self.modelScenePanel:setRotBgPos(0, 130)
	end
	
	if self.bInitModel or not self.modelScenePanel.bShowModel then
		self.modelScenePanel:setModelDir(data.uiModelDir)
		self.modelScenePanel:setModelScale(data.uiModelScale)
		self.modelScenePanel:addActIdEffs(Lua_ThingDefine.UIWAIT, data.poseActEffs)
		self.modelScenePanel:addActIdEffs(Lua_ThingDefine.UISHOW, data.showActEffs)
		self.modelScenePanel:showModelScene(data.uiSceneId, data.uiModelUrl, data.uiModelAvatarName, data.uiModelCamController)
		self.modelScenePanel:setModelAct(data.uiShowAct, Lua_ThingDefine.UIWAIT, true)
	end
	
	self.bInitModel = true
end

function Lua_ChaosForestWindow:onCheckHelp(go)
	local tipsData = { posX = 185, posY = -300, des = LanUtil.getValue(340015) };
	Lua_WindowUtil.openWin("Lua_InstructionTipsWindow", Lua_WinParam.ACTION_OPEN, tipsData);
end

function Lua_ChaosForestWindow:onCheckRank(go)
	DataCenter.funcPathUtil:gotoFunction(1085)
end

function Lua_ChaosForestWindow:onCheckNotice(go)
	Lua_WindowUtil.openWin("Lua_ChaosForestNoticeWindow", Lua_WinParam.ACTION_OPEN);
end

function Lua_ChaosForestWindow:onCheckRecord(go)
	Lua_WindowUtil.openWin("Lua_ChaosForestRecordWindow", Lua_WinParam.ACTION_OPEN);
end

function Lua_ChaosForestWindow:onCheckReward(go)
	Lua_WindowUtil.openWin("Lua_ChaosForestHurtRewardWindow", Lua_WinParam.ACTION_OPEN);
end

function Lua_ChaosForestWindow:onBtnChallengeClick(go)
	if self.bSettlement == true then
		OperateAlert.showLangValue(340007);
		return;
	end

	if self.recordId > 0 then
		DataCenter.fightData:showFightToStageByRid(self.recordId);
		return;
	end
	
	local free_times = DataCenter.chaosForestUtil:getConstConfig("free_times", 1, 0);
	if DataCenter.chaosForestData.challenge_times >= free_times then
		OperateAlert.showLangValue(340016);
		return;
	end

	local sceneId = DataCenter.heroLineupData:getFightLineupSceneId(Lua_FightDefine.TEMPLATE_ID_CHAOSFOREST);
	DataCenter.preLoadData:preShowScene("Lua_FightLineupWindow", Lua_PreLoadDefine.LOADSHOW_TYPE_NONE, self, self.onSceneShow, nil, sceneId, 0);
end

function Lua_ChaosForestWindow:onSceneShow(param)
	local bossId = DataCenter.chaosForestData.boss_id;
	local config = DataCenter.chaosForestUtil:getLevelConfig(bossId);
	param = { template_id = Lua_FightDefine.TEMPLATE_ID_CHAOSFOREST, stage_id = bossId, monster_player_id = config.monster_id };
	Lua_WindowUtil.openWin("Lua_FightLineupWindow", Lua_WinParam.ACTION_OPEN, param);
end


















Lua_ChaosForestItemIconCell = class("Lua_ChaosForestItemIconCell", Lua_ItemIconCell)
function Lua_ChaosForestItemIconCell:buildShowItem()
	self:superCall("buildShowItem");
	self.itemIcon:setScale(0.8, 0.8, 0.8);
end
























Lua_ChaosForestTagItem = class("Lua_ChaosForestTagItem", Lua_DisplayObject)
function Lua_ChaosForestTagItem:ctor(p)
	self:superCall("ctor", p, "ChaosForestTagItem_skin");
end

function Lua_ChaosForestTagItem:buildShowItem()
	self:superCall("buildShowItem");
end

function Lua_ChaosForestTagItem:dispose()
	self:superCall("dispose");
end

function Lua_ChaosForestTagItem:setData(data)
	if data[1] == 1 then
		self.arrowIcon:setAltas("chaos_forest_altas", "xui_yasl_label_3");
	else
		self.arrowIcon:setAltas("chaos_forest_altas", "xui_yasl_label_4");
	end
	self.tagText.text = data[2];
end